package server

import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
	slurmer "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/service"
	"context"
)

func ListNodes(ctx context.Context, req *pbslurm.ListNodesReq) (*pbslurm.ListNodesResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.ListNodes(ctx, req)
	return resp, nil
}

func GetAllJobs(ctx context.Context, req *pbslurm.JobInfoMsgReq) (*pbslurm.JobInfoMsgResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.GetAllJobs(ctx, req)
	return resp, nil
}

func GetJob(ctx context.Context, req *pbslurm.JobInfoMsgReq) (*pbslurm.JobInfoMsgResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.GetJob(ctx, req)
	return resp, nil
}

func SubmitJob(ctx context.Context, req *pbslurm.SubmitJobReq) (*pbslurm.SubmitJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.SubmitJob(ctx, req)
	return resp, nil
}

func DeleteJob(ctx context.Context, req *pbslurm.DeleteJobReq) (*pbslurm.DeleteJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.DeleteJob(ctx, req)
	return resp, nil
}

func UpdateJob(ctx context.Context, req *pbslurm.UpdateJobReq) (*pbslurm.UpdateJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.UpdateJob(ctx, req)
	return resp, nil
}

func GetDiag(ctx context.Context, req *pbslurm.DiagReq) (*pbslurm.DiagResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.GetDiag(ctx, req)
	return resp, nil
}

func GetQos(ctx context.Context, req *pbslurm.QosReq) (*pbslurm.QosResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.GetQos(ctx, req)
	return resp, nil
}

func GetSlurmdbJobs(ctx context.Context, req *pbslurm.SlurmDbJobReq) (*pbslurm.SlurmDbJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.GetSlurmdbJobs(ctx, req)
	return resp, nil
}

func GetSlurmdbJobById(ctx context.Context, req *pbslurm.SlurmDbJobReq) (*pbslurm.SlurmDbJobResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.GetSlurmdbJobById(ctx, req)
	return resp, nil
}

func DeleteQos(ctx context.Context, req *pbslurm.DeleteQosReq) (*pbslurm.DeleteQosResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.DeleteQos(ctx, req)
	return resp, nil
}

func AddQos(ctx context.Context, req *pbslurm.AddQosReq) (*pbslurm.AddQosResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.AddQos(ctx, req)
	return resp, nil
}

func GetQosByName(ctx context.Context, req *pbslurm.QosReq) (*pbslurm.QosResp, error) {
	slurm, _ := slurmer.SelectSlurmVersion(req.SlurmVersion)
	resp, _ := slurm.GetQosByName(ctx, req)
	return resp, nil
}
