package slurmer

/*
#cgo LDFLAGS: -lslurmdb
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include<slurm/slurm.h>
#include <slurm/slurmdb.h>
#include<slurm/slurm_errno.h>

inline uint8_t uint8_ptr(uint8_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
inline int8_t int8_ptr(int8_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
inline uint16_t uint16_ptr(uint16_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
inline int16_t int16_ptr(int16_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
inline uint32_t uint32_ptr(uint32_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
inline int32_t int32_ptr(int32_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
inline uint64_t uint64_ptr(uint64_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
inline int64_t int64_ptr(int16_t* pointer) {
    if (NULL == pointer) {
    return -1;}
    return *pointer;
}
*/
import "C"
import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
)

func Stats_convert_c_to_go(c_struct *C.stats_info_response_msg_t) Stats_info_response_msg {
	var go_struct Stats_info_response_msg

	go_struct.Agent_queue_size = uint32(c_struct.agent_queue_size)
	go_struct.Bf_active = uint32(c_struct.bf_active)
	go_struct.Bf_backfilled_jobs = uint32(c_struct.bf_backfilled_jobs)
	go_struct.Bf_cycle_counter = uint32(c_struct.bf_cycle_counter)
	go_struct.Bf_cycle_last = uint32(c_struct.bf_cycle_last)
	go_struct.Bf_cycle_max = uint32(c_struct.bf_cycle_max)
	go_struct.Bf_cycle_sum = uint32(c_struct.bf_cycle_sum)
	go_struct.Bf_depth_sum = uint32(c_struct.bf_depth_sum)
	go_struct.Bf_depth_try_sum = uint32(c_struct.bf_depth_try_sum)
	go_struct.Bf_last_backfilled_jobs = uint32(c_struct.bf_last_backfilled_jobs)
	go_struct.Bf_last_depth = uint32(c_struct.bf_last_depth)
	go_struct.Bf_last_depth_try = uint32(c_struct.bf_last_depth_try)
	go_struct.Bf_queue_len = uint32(c_struct.bf_queue_len)
	go_struct.Bf_queue_len_sum = uint32(c_struct.bf_queue_len_sum)
	go_struct.Bf_when_last_cycle = int64(c_struct.bf_when_last_cycle)
	go_struct.Jobs_completed = uint32(c_struct.jobs_completed)
	go_struct.Jobs_canceled = uint32(c_struct.jobs_canceled)
	go_struct.Jobs_failed = uint32(c_struct.jobs_failed)
	go_struct.Jobs_started = uint32(c_struct.jobs_started)
	go_struct.Jobs_submitted = uint32(c_struct.jobs_submitted)
	go_struct.Parts_packed = uint32(c_struct.parts_packed)
	go_struct.Req_time = int64(c_struct.req_time)
	go_struct.Req_time_start = int64(c_struct.req_time_start)
	go_struct.Schedule_cycle_depth = uint32(c_struct.schedule_cycle_depth)
	go_struct.Schedule_cycle_counter = uint32(c_struct.schedule_cycle_counter)
	go_struct.Schedule_cycle_last = uint32(c_struct.schedule_cycle_last)
	go_struct.Schedule_cycle_max = uint32(c_struct.schedule_cycle_max)
	go_struct.Schedule_cycle_sum = uint32(c_struct.schedule_cycle_sum)
	go_struct.Schedule_queue_len = uint32(c_struct.schedule_queue_len)
	go_struct.Server_thread_count = uint32(c_struct.server_thread_count)

	return go_struct
}
func Job_info_convert_c_to_go(c_struct *C.struct_job_info) Job_info {
	var go_struct Job_info

	go_struct.Account = C.GoString(c_struct.account)
	go_struct.Alloc_node = C.GoString(c_struct.alloc_node)
	go_struct.Alloc_sid = uint32(c_struct.alloc_sid)
	go_struct.Array_job_id = uint32(c_struct.array_job_id)
	go_struct.Array_task_id = uint16(c_struct.array_task_id)
	go_struct.Assoc_id = uint32(c_struct.assoc_id)
	go_struct.Batch_flag = uint16(c_struct.batch_flag)
	go_struct.Batch_host = C.GoString(c_struct.batch_host)
	go_struct.Boards_per_node = uint16(c_struct.boards_per_node)
	go_struct.Batch_script = C.GoString(c_struct.batch_script)
	go_struct.Command = C.GoString(c_struct.command)
	go_struct.Comment = C.GoString(c_struct.comment)
	go_struct.Contiguous = uint16(c_struct.contiguous)
	go_struct.Cores_per_socket = uint16(c_struct.cores_per_socket)
	go_struct.Cpus_per_task = uint16(c_struct.cpus_per_task)
	go_struct.Dependency = C.GoString(c_struct.dependency)
	go_struct.Derived_ec = uint32(c_struct.derived_ec)
	go_struct.Eligible_time = int64(c_struct.eligible_time)
	go_struct.End_time = int64(c_struct.end_time)
	go_struct.Exc_nodes = C.GoString(c_struct.exc_nodes)
	go_struct.Exc_node_inx = int32(C.int32_ptr(c_struct.exc_node_inx))
	go_struct.Exit_code = uint32(c_struct.exit_code)
	go_struct.Features = C.GoString(c_struct.features)
	go_struct.Group_id = uint32(c_struct.group_id)
	go_struct.Gres = C.GoString(c_struct.gres)
	go_struct.Job_id = uint32(c_struct.job_id)
	go_struct.Job_state = uint16(c_struct.job_state)
	go_struct.Licenses = C.GoString(c_struct.licenses)
	go_struct.Max_cpus = uint32(c_struct.max_cpus)
	go_struct.Max_nodes = uint32(c_struct.max_nodes)
	go_struct.Name = C.GoString(c_struct.name)
	go_struct.Network = C.GoString(c_struct.network)
	go_struct.Nodes = C.GoString(c_struct.nodes)
	go_struct.Nice = uint16(c_struct.nice)
	go_struct.Node_inx = int32(C.int32_ptr(c_struct.node_inx))
	go_struct.Ntasks_per_core = uint16(c_struct.ntasks_per_core)
	go_struct.Ntasks_per_node = uint16(c_struct.ntasks_per_node)
	go_struct.Ntasks_per_socket = uint16(c_struct.ntasks_per_socket)
	go_struct.Ntasks_per_board = uint16(c_struct.ntasks_per_board)
	go_struct.Num_cpus = uint32(c_struct.num_cpus)
	go_struct.Num_nodes = uint32(c_struct.num_nodes)
	go_struct.Partition = C.GoString(c_struct.partition)
	go_struct.Pn_min_memory = uint32(c_struct.pn_min_memory)
	go_struct.Pn_min_cpus = uint16(c_struct.pn_min_cpus)
	go_struct.Pn_min_tmp_disk = uint32(c_struct.pn_min_tmp_disk)
	go_struct.Preempt_time = int64(c_struct.preempt_time)
	go_struct.Pre_sus_time = int64(c_struct.pre_sus_time)
	go_struct.Priority = uint32(c_struct.priority)
	go_struct.Profile = uint32(c_struct.profile)
	go_struct.Qos = C.GoString(c_struct.qos)
	go_struct.Req_nodes = C.GoString(c_struct.req_nodes)
	go_struct.Req_node_inx = int32(C.int32_ptr(c_struct.req_node_inx))
	go_struct.Req_switch = uint32(c_struct.req_switch)
	go_struct.Requeue = uint16(c_struct.requeue)
	go_struct.Resize_time = int64(c_struct.resize_time)
	go_struct.Restart_cnt = uint16(c_struct.restart_cnt)
	go_struct.Resv_name = C.GoString(c_struct.resv_name)
	go_struct.Shared = uint16(c_struct.shared)
	go_struct.Show_flags = uint16(c_struct.show_flags)
	go_struct.Sockets_per_board = uint16(c_struct.sockets_per_board)
	go_struct.Sockets_per_node = uint16(c_struct.sockets_per_node)
	go_struct.Start_time = int64(c_struct.start_time)
	go_struct.State_desc = C.GoString(c_struct.state_desc)
	go_struct.State_reason = uint16(c_struct.state_reason)
	go_struct.Submit_time = int64(c_struct.submit_time)
	go_struct.Suspend_time = int64(c_struct.suspend_time)
	go_struct.Time_limit = uint32(c_struct.time_limit)
	go_struct.Time_min = uint32(c_struct.time_min)
	go_struct.Threads_per_core = uint16(c_struct.threads_per_core)
	go_struct.User_id = uint32(c_struct.user_id)
	go_struct.Wait4switch = uint32(c_struct.wait4switch)
	go_struct.Wckey = C.GoString(c_struct.wckey)
	go_struct.Work_dir = C.GoString(c_struct.work_dir)

	return go_struct
}

func Job_descriptor_convert_c_to_go(c_struct *C.struct_job_descriptor) Job_descriptor {
	var go_struct Job_descriptor

	go_struct.Account = C.GoString(c_struct.account)
	go_struct.Acctg_freq = C.GoString(c_struct.acctg_freq)
	go_struct.Alloc_node = C.GoString(c_struct.alloc_node)
	go_struct.Alloc_resp_port = uint16(c_struct.alloc_resp_port)
	go_struct.Alloc_sid = uint32(c_struct.alloc_sid)
	go_struct.Argc = uint32(c_struct.argc)
	go_struct.Array_inx = C.GoString(c_struct.array_inx)
	go_struct.Begin_time = int64(c_struct.begin_time)
	go_struct.Ckpt_interval = uint16(c_struct.ckpt_interval)
	go_struct.Ckpt_dir = C.GoString(c_struct.ckpt_dir)
	go_struct.Comment = C.GoString(c_struct.comment)
	go_struct.Contiguous = uint16(c_struct.contiguous)
	go_struct.Cpu_bind = C.GoString(c_struct.cpu_bind)
	go_struct.Cpu_bind_type = uint16(c_struct.cpu_bind_type)
	go_struct.Dependency = C.GoString(c_struct.dependency)
	go_struct.End_time = int64(c_struct.end_time)
	go_struct.Env_size = uint32(c_struct.env_size)
	go_struct.Exc_nodes = C.GoString(c_struct.exc_nodes)
	go_struct.Features = C.GoString(c_struct.features)
	go_struct.Group_id = uint32(c_struct.group_id)
	go_struct.Immediate = uint16(c_struct.immediate)
	go_struct.Job_id = uint32(c_struct.job_id)
	go_struct.Kill_on_node_fail = uint16(c_struct.kill_on_node_fail)
	go_struct.Licenses = C.GoString(c_struct.licenses)
	go_struct.Mail_type = uint16(c_struct.mail_type)
	go_struct.Mail_user = C.GoString(c_struct.mail_user)
	go_struct.Mem_bind = C.GoString(c_struct.mem_bind)
	go_struct.Mem_bind_type = uint16(c_struct.mem_bind_type)
	go_struct.Name = C.GoString(c_struct.name)
	go_struct.Network = C.GoString(c_struct.network)
	go_struct.Nice = uint16(c_struct.nice)
	go_struct.Num_tasks = uint32(c_struct.num_tasks)
	go_struct.Open_mode = uint8(c_struct.open_mode)
	go_struct.Other_port = uint16(c_struct.other_port)
	go_struct.Overcommit = uint8(c_struct.overcommit)
	go_struct.Partition = C.GoString(c_struct.partition)
	go_struct.Plane_size = uint16(c_struct.plane_size)
	go_struct.Priority = uint32(c_struct.priority)
	go_struct.Profile = uint32(c_struct.profile)
	go_struct.Qos = C.GoString(c_struct.qos)
	go_struct.Reboot = uint16(c_struct.reboot)
	go_struct.Resp_host = C.GoString(c_struct.resp_host)
	go_struct.Req_nodes = C.GoString(c_struct.req_nodes)
	go_struct.Requeue = uint16(c_struct.requeue)
	go_struct.Reservation = C.GoString(c_struct.reservation)
	go_struct.Script = C.GoString(c_struct.script)
	go_struct.Shared = uint16(c_struct.shared)
	go_struct.Spank_job_env_size = uint32(c_struct.spank_job_env_size)
	go_struct.Task_dist = uint16(c_struct.task_dist)
	go_struct.Time_limit = uint32(c_struct.time_limit)
	go_struct.Time_min = uint32(c_struct.time_min)
	go_struct.User_id = uint32(c_struct.user_id)
	go_struct.Wait_all_nodes = uint16(c_struct.wait_all_nodes)
	go_struct.Warn_signal = uint16(c_struct.warn_signal)
	go_struct.Warn_time = uint16(c_struct.warn_time)
	go_struct.Work_dir = C.GoString(c_struct.work_dir)
	go_struct.Cpus_per_task = uint16(c_struct.cpus_per_task)
	go_struct.Min_cpus = uint32(c_struct.min_cpus)
	go_struct.Max_cpus = uint32(c_struct.max_cpus)
	go_struct.Min_nodes = uint32(c_struct.min_nodes)
	go_struct.Max_nodes = uint32(c_struct.max_nodes)
	go_struct.Boards_per_node = uint16(c_struct.boards_per_node)
	go_struct.Sockets_per_board = uint16(c_struct.sockets_per_board)
	go_struct.Sockets_per_node = uint16(c_struct.sockets_per_node)
	go_struct.Cores_per_socket = uint16(c_struct.cores_per_socket)
	go_struct.Threads_per_core = uint16(c_struct.threads_per_core)
	go_struct.Ntasks_per_node = uint16(c_struct.ntasks_per_node)
	go_struct.Ntasks_per_socket = uint16(c_struct.ntasks_per_socket)
	go_struct.Ntasks_per_core = uint16(c_struct.ntasks_per_core)
	go_struct.Ntasks_per_board = uint16(c_struct.ntasks_per_board)
	go_struct.Pn_min_cpus = uint16(c_struct.pn_min_cpus)
	go_struct.Pn_min_memory = uint32(c_struct.pn_min_memory)
	go_struct.Pn_min_tmp_disk = uint32(c_struct.pn_min_tmp_disk)
	go_struct.Req_switch = uint32(c_struct.req_switch)
	go_struct.Std_err = C.GoString(c_struct.std_err)
	go_struct.Std_in = C.GoString(c_struct.std_in)
	go_struct.Std_out = C.GoString(c_struct.std_out)
	go_struct.Wait4switch = uint32(c_struct.wait4switch)
	go_struct.Wckey = C.GoString(c_struct.wckey)

	return go_struct
}

func submit_response_msg_convert_c_to_go(c_struct *C.struct_submit_response_msg) Submit_response_msg {
	var go_struct Submit_response_msg

	go_struct.Job_id = uint32(c_struct.job_id)
	go_struct.Step_id = uint32(c_struct.step_id)
	go_struct.Error_code = uint32(c_struct.error_code)
	return go_struct
}

func Qos_convert_c_to_go(c_struct *C.slurmdb_qos_rec_t) pbslurm.SlurmdbQosRec {
	var go_struct pbslurm.SlurmdbQosRec

	go_struct.Description = C.GoString(c_struct.description)
	go_struct.Flags = uint32(c_struct.flags)
	go_struct.GrpCpus = uint32(c_struct.grp_cpus)
	go_struct.GraceTime = uint32(c_struct.grace_time)
	go_struct.GrpCpuMins = uint64(c_struct.grp_cpu_mins)
	go_struct.GrpCpuRunMins = uint64(c_struct.grp_cpu_run_mins)
	go_struct.GrpJobs = uint32(c_struct.grp_jobs)
	go_struct.GrpMem = uint32(c_struct.grp_mem)
	go_struct.GrpNodes = uint32(c_struct.grp_nodes)
	go_struct.GrpSubmitJobs = uint32(c_struct.grp_submit_jobs)
	go_struct.GrpWall = uint32(c_struct.grp_wall)
	go_struct.Id = uint32(c_struct.id)
	go_struct.MaxCpusPj = uint32(c_struct.max_cpus_pj)
	go_struct.MaxCpuMinsPj = uint64(c_struct.max_cpu_mins_pj)
	go_struct.MaxCpusPu = uint32(c_struct.max_cpus_pu)
	go_struct.MaxJobsPu = uint32(c_struct.max_jobs_pu)
	go_struct.MaxCpuRunMinsPu = uint64(c_struct.max_cpu_run_mins_pu)
	go_struct.MaxNodesPj = uint32(c_struct.max_nodes_pj)
	go_struct.MaxNodesPu = uint32(c_struct.max_nodes_pu)
	go_struct.MaxSubmitJobsPu = uint32(c_struct.max_submit_jobs_pu)
	go_struct.MaxWallPj = uint32(c_struct.max_wall_pj)
	go_struct.Name = C.GoString(c_struct.name)
	go_struct.Priority = uint32(c_struct.priority)
	//go_struct.PreemptList = c_struct.preempt_list
	go_struct.PreemptMode = uint32(c_struct.preempt_mode)
	go_struct.UsageThres = float64(c_struct.usage_factor)
	go_struct.UsageFactor = float64(c_struct.usage_thres)

	return go_struct
}

func Slurmdb_Job_convert_c_to_go(c_struct_job *C.slurmdb_job_rec_t) pbslurm.SlurmdbJobRec {
	var go_struct pbslurm.SlurmdbJobRec

	go_struct.Account = C.GoString(c_struct_job.account)
	go_struct.Associd = uint32(c_struct_job.associd)
	go_struct.AllocCpu = uint32(c_struct_job.alloc_cpus)
	go_struct.AllocNodes = uint32(c_struct_job.alloc_nodes)
	go_struct.Blockid = C.GoString(c_struct_job.blockid)
	go_struct.Cluster = C.GoString(c_struct_job.cluster)
	go_struct.DerivedEs = C.GoString(c_struct_job.derived_es)
	go_struct.DerivedEc = uint32(c_struct_job.derived_ec)
	go_struct.End = int64(c_struct_job.end)
	go_struct.Elapsed = uint32(c_struct_job.elapsed)
	go_struct.Eligible = int64(c_struct_job.eligible)
	go_struct.Exitcode = uint32(c_struct_job.exitcode)
	go_struct.Gid = uint32(c_struct_job.gid)
	go_struct.Jobid = uint32(c_struct_job.jobid)
	go_struct.Jobname = C.GoString(c_struct_job.jobname)
	go_struct.Lft = uint32(c_struct_job.lft)
	go_struct.Nodes = C.GoString(c_struct_job.nodes)
	go_struct.Priority = uint32(c_struct_job.priority)
	go_struct.Partition = C.GoString(c_struct_job.partition)
	//go_struct.Qosid = c_struct_job
	//go_struct.Requid = c_struct_job
	//go_struct.ReqMem = c_struct_job
	//go_struct.ReqCpus = c_struct_job
	//go_struct.Resvid = c_struct_job
	//go_struct.Stats = c_struct_job
	//go_struct.Start = c_struct_job
	//go_struct.ShowFull = c_struct_job
	//go_struct.State = c_struct_job
	//go_struct.Submit = c_struct_job

	//var stats_adrs []*pbslurm.SlurmdbStatsT
	//var stats pbslurm.SlurmdbStatsT
	//stat.ActCpufreq = float64(c_struct_job.stats.act_cpufreq)
	//stats.CpuMin = uint32((c_struct_job.stats).cpu_min)
	//stat.CpuAve = float64(c_struct_job.stats.cpu_ave)
	//stats_adrs = append(stats_adrs, &stats)
	//go_struct.Stats = stats

	return go_struct
}
