package slurmer

/*
//#cgo LDFLAGS: -lslurm
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include<slurm/slurm.h>
#include<slurm/slurm_errno.h>

struct submit_response_msg *submit_job(struct job_descriptor *desc)
{

	struct submit_response_msg *resp_msg;
	if (slurm_submit_batch_job(desc,
				&resp_msg)) {
		return NULL;
	}
	return resp_msg;

}

void free_submit_response_msg(struct submit_response_msg *msg)
{
	 slurm_free_submit_response_response_msg(msg);
}

int update_job (struct job_descriptor *msg) {

	 return slurm_update_job (msg);
}
*/
import "C"
import (
	"fmt"
	"unsafe"
)

func Submit_job(go_struct *Job_descriptor) Submit_response_msg {

	var c_struct C.struct_job_descriptor

	C.slurm_init_job_desc_msg(&c_struct)
	if go_struct.Account != "" {
		account_s := C.CString(go_struct.Account)
		defer C.free(unsafe.Pointer(account_s))
		c_struct.account = account_s
	}
	if go_struct.Acctg_freq != "" {
		acctg_freq_s := C.CString(go_struct.Acctg_freq)
		defer C.free(unsafe.Pointer(acctg_freq_s))
		c_struct.acctg_freq = acctg_freq_s
	}
	if go_struct.Alloc_node != "" {
		alloc_node_s := C.CString(go_struct.Alloc_node)
		defer C.free(unsafe.Pointer(alloc_node_s))
		c_struct.alloc_node = alloc_node_s
	}
	if go_struct.Alloc_resp_port != 0 {
		c_struct.alloc_resp_port = C.uint16_t(go_struct.Alloc_resp_port)
	}
	if go_struct.Alloc_sid != 0 {
		c_struct.alloc_sid = C.uint32_t(go_struct.Alloc_sid)
	}
	if len(go_struct.Argv) > 0 {
		c_struct.argc = C.uint32_t(len(go_struct.Argv))
		cArray := C.malloc(C.size_t(C.size_t(len(go_struct.Argv)) * C.size_t(unsafe.Sizeof(uintptr(0)))))
		a := (*[1<<30 - 1]*C.char)(cArray)
		for i := 0; i < len(go_struct.Argv); i++ {
			a[i] = C.CString(go_struct.Argv[i])
		}
		c_struct.argv = (**C.char)(cArray)
		fmt.Printf("test\n")
	}

	if go_struct.Array_inx != "" {
		array_inx_s := C.CString(go_struct.Array_inx)
		defer C.free(unsafe.Pointer(array_inx_s))
		c_struct.array_inx = array_inx_s
	}
	if go_struct.Begin_time != 0 {
		c_struct.begin_time = C.int64_t(go_struct.Begin_time)
	}
	if go_struct.Ckpt_interval != 0 {
		c_struct.ckpt_interval = C.uint16_t(go_struct.Ckpt_interval)
	}
	if go_struct.Ckpt_dir != "" {
		ckpt_dir_s := C.CString(go_struct.Ckpt_dir)
		defer C.free(unsafe.Pointer(ckpt_dir_s))
		c_struct.ckpt_dir = ckpt_dir_s
	}
	if go_struct.Comment != "" {
		comment_s := C.CString(go_struct.Comment)
		defer C.free(unsafe.Pointer(comment_s))
		c_struct.comment = comment_s
	}
	if go_struct.Contiguous != 0 {
		c_struct.contiguous = C.uint16_t(go_struct.Contiguous)
	}
	if go_struct.Cpu_bind != "" {
		cpu_bind_s := C.CString(go_struct.Cpu_bind)
		defer C.free(unsafe.Pointer(cpu_bind_s))
		c_struct.cpu_bind = cpu_bind_s
	}
	if go_struct.Cpu_bind_type != 0 {
		c_struct.cpu_bind_type = C.uint16_t(go_struct.Cpu_bind_type)
	}
	if go_struct.Dependency != "" {
		dependency_s := C.CString(go_struct.Dependency)
		defer C.free(unsafe.Pointer(dependency_s))
		c_struct.dependency = dependency_s
	}
	if go_struct.End_time != 0 {
		c_struct.end_time = C.int64_t(go_struct.End_time)
	}
	if len(go_struct.Environment) > 0 {
		c_struct.env_size = C.uint32_t(len(go_struct.Environment))
		cArray := C.malloc(C.size_t(C.size_t(len(go_struct.Environment)) * C.size_t(unsafe.Sizeof(uintptr(0)))))
		a := (*[1<<30 - 1]*C.char)(cArray)
		for i := 0; i < len(go_struct.Environment); i++ {
			a[i] = C.CString(go_struct.Environment[i])
			defer C.free(unsafe.Pointer(a[i]))
		}
		c_struct.environment = (**C.char)(cArray)
	} else {
		c_struct.env_size = 1
		cArray := C.malloc(C.size_t(C.size_t(1) * C.size_t(unsafe.Sizeof(uintptr(0)))))
		a := (*[1<<30 - 1]*C.char)(cArray)
		a[0] = C.CString("SLURM_GO_JOB=TRUE")
		defer C.free(unsafe.Pointer(a[0]))
		c_struct.environment = (**C.char)(cArray)

	}
	if go_struct.Exc_nodes != "" {
		exc_nodes_s := C.CString(go_struct.Exc_nodes)
		defer C.free(unsafe.Pointer(exc_nodes_s))
		c_struct.exc_nodes = exc_nodes_s
	}
	if go_struct.Features != "" {
		features_s := C.CString(go_struct.Features)
		defer C.free(unsafe.Pointer(features_s))
		c_struct.features = features_s
	}
	if go_struct.Group_id != 0 {
		c_struct.group_id = C.uint32_t(go_struct.Group_id)
	}
	if go_struct.Immediate != 0 {
		c_struct.immediate = C.uint16_t(go_struct.Immediate)
	}
	if go_struct.Job_id != 0 {
		c_struct.job_id = C.uint32_t(go_struct.Job_id)
	}
	if go_struct.Kill_on_node_fail != 0 {
		c_struct.kill_on_node_fail = C.uint16_t(go_struct.Kill_on_node_fail)
	}
	if go_struct.Licenses != "" {
		licenses_s := C.CString(go_struct.Licenses)
		defer C.free(unsafe.Pointer(licenses_s))
		c_struct.licenses = licenses_s
	}
	if go_struct.Mail_type != 0 {
		c_struct.mail_type = C.uint16_t(go_struct.Mail_type)
	}
	if go_struct.Mail_user != "" {
		mail_user_s := C.CString(go_struct.Mail_user)
		defer C.free(unsafe.Pointer(mail_user_s))
		c_struct.mail_user = mail_user_s
	}
	if go_struct.Mem_bind != "" {
		mem_bind_s := C.CString(go_struct.Mem_bind)
		defer C.free(unsafe.Pointer(mem_bind_s))
		c_struct.mem_bind = mem_bind_s
	}
	if go_struct.Mem_bind_type != 0 {
		c_struct.mem_bind_type = C.uint16_t(go_struct.Mem_bind_type)
	}
	if go_struct.Name != "" {
		name_s := C.CString(go_struct.Name)
		defer C.free(unsafe.Pointer(name_s))
		c_struct.name = name_s
	}
	if go_struct.Network != "" {
		network_s := C.CString(go_struct.Network)
		defer C.free(unsafe.Pointer(network_s))
		c_struct.network = network_s
	}
	if go_struct.Nice != 0 {
		c_struct.nice = C.uint16_t(go_struct.Nice)
	}
	if go_struct.Num_tasks != 0 {
		c_struct.num_tasks = C.uint32_t(go_struct.Num_tasks)
	}
	if go_struct.Open_mode != 0 {
		c_struct.open_mode = C.uint8_t(go_struct.Open_mode)
	}
	if go_struct.Other_port != 0 {
		c_struct.other_port = C.uint16_t(go_struct.Other_port)
	}
	if go_struct.Overcommit != 0 {
		c_struct.overcommit = C.uint8_t(go_struct.Overcommit)
	}
	if go_struct.Partition != "" {
		partition_s := C.CString(go_struct.Partition)
		defer C.free(unsafe.Pointer(partition_s))
		c_struct.partition = partition_s
	}
	if go_struct.Plane_size != 0 {
		c_struct.plane_size = C.uint16_t(go_struct.Plane_size)
	}
	if go_struct.Priority != 0 {
		c_struct.priority = C.uint32_t(go_struct.Priority)
	}
	if go_struct.Profile != 0 {
		c_struct.profile = C.uint32_t(go_struct.Profile)
	}
	if go_struct.Qos != "" {
		qos_s := C.CString(go_struct.Qos)
		defer C.free(unsafe.Pointer(qos_s))
		c_struct.qos = qos_s
	}
	if go_struct.Reboot != 0 {
		c_struct.reboot = C.uint16_t(go_struct.Reboot)
	}
	if go_struct.Resp_host != "" {
		resp_host_s := C.CString(go_struct.Resp_host)
		defer C.free(unsafe.Pointer(resp_host_s))
		c_struct.resp_host = resp_host_s
	}
	if go_struct.Req_nodes != "" {
		req_nodes_s := C.CString(go_struct.Req_nodes)
		defer C.free(unsafe.Pointer(req_nodes_s))
		c_struct.req_nodes = req_nodes_s
	}
	if go_struct.Requeue != 0 {
		c_struct.requeue = C.uint16_t(go_struct.Requeue)
	}
	if go_struct.Reservation != "" {
		reservation_s := C.CString(go_struct.Reservation)
		defer C.free(unsafe.Pointer(reservation_s))
		c_struct.reservation = reservation_s
	}
	if go_struct.Script != "" {
		script_s := C.CString(go_struct.Script)
		defer C.free(unsafe.Pointer(script_s))
		c_struct.script = script_s
	}
	if go_struct.Shared != 0 {
		c_struct.shared = C.uint16_t(go_struct.Shared)
	}
	if go_struct.Spank_job_env_size != 0 {
		c_struct.spank_job_env_size = C.uint32_t(go_struct.Spank_job_env_size)
	}
	if go_struct.Task_dist != 0 {
		c_struct.task_dist = C.uint16_t(go_struct.Task_dist)
	}
	if go_struct.Time_limit != 0 {
		c_struct.time_limit = C.uint32_t(go_struct.Time_limit)
	}
	if go_struct.Time_min != 0 {
		c_struct.time_min = C.uint32_t(go_struct.Time_min)
	}
	//if go_struct.User_id != 0 {
	//	c_struct.user_id = C.uint32_t(go_struct.User_id)
	//}
	c_struct.user_id = C.uint32_t(go_struct.User_id)
	if go_struct.Wait_all_nodes != 0 {
		c_struct.wait_all_nodes = C.uint16_t(go_struct.Wait_all_nodes)
	}
	if go_struct.Warn_signal != 0 {
		c_struct.warn_signal = C.uint16_t(go_struct.Warn_signal)
	}
	if go_struct.Warn_time != 0 {
		c_struct.warn_time = C.uint16_t(go_struct.Warn_time)
	}
	if go_struct.Work_dir != "" {
		work_dir_s := C.CString(go_struct.Work_dir)
		defer C.free(unsafe.Pointer(work_dir_s))
		c_struct.work_dir = work_dir_s
	}
	if go_struct.Cpus_per_task != 0 {
		c_struct.cpus_per_task = C.uint16_t(go_struct.Cpus_per_task)
	}
	if go_struct.Min_cpus != 0 {
		c_struct.min_cpus = C.uint32_t(go_struct.Min_cpus)
	}
	if go_struct.Max_cpus != 0 {
		c_struct.max_cpus = C.uint32_t(go_struct.Max_cpus)
	}
	if go_struct.Min_nodes != 0 {
		c_struct.min_nodes = C.uint32_t(go_struct.Min_nodes)
	}
	if go_struct.Max_nodes != 0 {
		c_struct.max_nodes = C.uint32_t(go_struct.Max_nodes)
	}
	if go_struct.Boards_per_node != 0 {
		c_struct.boards_per_node = C.uint16_t(go_struct.Boards_per_node)
	}
	if go_struct.Sockets_per_board != 0 {
		c_struct.sockets_per_board = C.uint16_t(go_struct.Sockets_per_board)
	}
	if go_struct.Sockets_per_node != 0 {
		c_struct.sockets_per_node = C.uint16_t(go_struct.Sockets_per_node)
	}
	if go_struct.Cores_per_socket != 0 {
		c_struct.cores_per_socket = C.uint16_t(go_struct.Cores_per_socket)
	}
	if go_struct.Threads_per_core != 0 {
		c_struct.threads_per_core = C.uint16_t(go_struct.Threads_per_core)
	}
	if go_struct.Ntasks_per_node != 0 {
		c_struct.ntasks_per_node = C.uint16_t(go_struct.Ntasks_per_node)
	}
	if go_struct.Ntasks_per_socket != 0 {
		c_struct.ntasks_per_socket = C.uint16_t(go_struct.Ntasks_per_socket)
	}
	if go_struct.Ntasks_per_core != 0 {
		c_struct.ntasks_per_core = C.uint16_t(go_struct.Ntasks_per_core)
	}
	if go_struct.Ntasks_per_board != 0 {
		c_struct.ntasks_per_board = C.uint16_t(go_struct.Ntasks_per_board)
	}
	if go_struct.Pn_min_cpus != 0 {
		c_struct.pn_min_cpus = C.uint16_t(go_struct.Pn_min_cpus)
	}
	if go_struct.Pn_min_memory != 0 {
		c_struct.pn_min_memory = C.uint32_t(go_struct.Pn_min_memory)
	}
	if go_struct.Pn_min_tmp_disk != 0 {
		c_struct.pn_min_tmp_disk = C.uint32_t(go_struct.Pn_min_tmp_disk)
	}
	if go_struct.Req_switch != 0 {
		c_struct.req_switch = C.uint32_t(go_struct.Req_switch)
	}
	if go_struct.Std_err != "" {
		std_err_s := C.CString(go_struct.Std_err)
		defer C.free(unsafe.Pointer(std_err_s))
		c_struct.std_err = std_err_s
	}
	if go_struct.Std_in != "" {
		std_in_s := C.CString(go_struct.Std_in)
		defer C.free(unsafe.Pointer(std_in_s))
		c_struct.std_in = std_in_s
	}
	if go_struct.Std_out != "" {
		std_out_s := C.CString(go_struct.Std_out)
		defer C.free(unsafe.Pointer(std_out_s))
		c_struct.std_out = std_out_s
	}

	if go_struct.Wait4switch != 0 {
		c_struct.wait4switch = C.uint32_t(go_struct.Wait4switch)
	}
	if go_struct.Wckey != "" {
		wckey_s := C.CString(go_struct.Wckey)
		defer C.free(unsafe.Pointer(wckey_s))
		c_struct.wckey = wckey_s
	}

	c_msg := C.submit_job(&c_struct)

	defer C.free_submit_response_msg(c_msg)
	if c_msg == nil {
		go_msg := Submit_response_msg{}
		go_msg.Job_id = 1<<31 - 1
		go_msg.Error_code = uint32(C.slurm_get_errno())
		return go_msg
	}
	go_msg := submit_response_msg_convert_c_to_go(c_msg)

	return go_msg

}

func Update_job(update_info Update_job_options, JobId uint32) int32 {

	var c_struct C.struct_job_descriptor
	C.slurm_init_job_desc_msg(&c_struct)
	if update_info.Partition != "" {
		partition_s := C.CString(update_info.Partition)
		defer C.free(unsafe.Pointer(partition_s))
		c_struct.partition = partition_s
	}
	if update_info.Qos != "" {
		qos_s := C.CString(update_info.Qos)
		defer C.free(unsafe.Pointer(qos_s))
		c_struct.qos = qos_s
	}
	if update_info.Num_tasks != 0 {
		c_struct.num_tasks = C.uint32_t(update_info.Num_tasks)
	}
	if update_info.Ntasks_per_core != 0 {
		c_struct.ntasks_per_core = C.uint16_t(update_info.Ntasks_per_core)
	}

	if update_info.Ntasks_per_node != 0 {
		c_struct.ntasks_per_node = C.uint16_t(update_info.Ntasks_per_node)
	}
	if update_info.Ntasks_per_socket != 0 {
		c_struct.ntasks_per_socket = C.uint16_t(update_info.Ntasks_per_socket)
	}

	if update_info.Max_nodes != 0 {
		c_struct.max_nodes = C.uint32_t(update_info.Max_nodes)
	}
	if update_info.Min_nodes != 0 {
		c_struct.min_nodes = C.uint32_t(update_info.Min_nodes)
	}

	job_list := Get_job(JobId)

	if job_list.Job_list == nil {
		return -1
	}

	job := job_list.Job_list[0]
	if job.Job_state != C.JOB_PENDING {
		return int32(C.ESLURM_JOB_NOT_PENDING)
	}
	c_struct.job_id = C.uint32_t(JobId)

	err := C.update_job(&c_struct)

	return int32(err)

}
