package slurmer

/*
#cgo LDFLAGS: -lslurmdb

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <slurm/slurm.h>
#include <slurm/slurmdb.h>
#include <slurm/slurm_errno.h>
#include <memory.h>
#include <malloc.h>

slurmdb_job_rec_t *get_all_slurmdb_job() {

    slurmdb_job_cond_t *job_cond = NULL;
	void *conn = slurmdb_connection_get();

	List joblist = slurmdb_jobs_get(conn, job_cond);

	uint16_t listsize = slurm_list_count(joblist);
	//qosinfo.record_count = size;
	slurmdb_job_rec_t *jobarray = malloc(listsize * sizeof(slurmdb_job_rec_t));

	ListIterator itr = slurm_list_iterator_create(joblist);

    slurmdb_job_rec_t *rec = NULL;
	int i = 0;
	while ((rec = slurm_list_next(itr))) {
  		jobarray[i] = *rec;
  		i++;
	}
	slurmdb_connection_close(&conn);
	slurm_list_destroy(joblist);
	//int arraysize = sizeof(jobarray);
	//printf("%d\n", arraysize);
	return jobarray;
}

slurmdb_job_rec_t *job_from_array(slurmdb_job_rec_t *job_rec_array, int i) {
  return (slurmdb_job_rec_t *) &(job_rec_array[i]);
}

slurmdb_job_rec_t *job_from_array_by_id(slurmdb_job_rec_t *job_rec_array, int job_id) {
	int i;
    int arraysize = sizeof(job_rec_array);
    for (i=0; i<arraysize; i++)
    {
         //printf("var: %d : %p : %d \n", var, &(job_rec_array[var]), (job_rec_array[var]).stats.cpu_min);
         //printf("%d \n",(job_rec_array[i]).stats.cpu_min);
         //printf("var: %d : %p : %d \n", var, &(job_rec_array[var]), (job_rec_array[var]).jobid);
         if (job_id==(job_rec_array[i]).jobid)
         {
			break;
         } else {
			return NULL;
         }
    }
	return (slurmdb_job_rec_t *) &(job_rec_array[i]);

}
int getLength(slurmdb_job_rec_t *job_rec_array) {
  return sizeof(job_rec_array);
}

*/
import "C"
import (
	pbslurm "code.gitlink.org.cn/JCCE/PCM.git/adaptor/pcm_slurm/gen/idl"
)

func GetAllSlurmdbJobs() []pbslurm.SlurmdbJobRec {
	slurmJobs := []pbslurm.SlurmdbJobRec{}
	jobarray := C.get_all_slurmdb_job()
	size := uint32(C.getLength(jobarray))
	for i := uint32(0); i < size; i++ {
		c_job := C.job_from_array(jobarray, C.int(i))
		go_job := Slurmdb_Job_convert_c_to_go(c_job)
		slurmJobs = append(slurmJobs, go_job)
	}
	return slurmJobs
}

func GetSlurmdbJobById(job_id int) []pbslurm.SlurmdbJobRec {
	slurmJobs := []pbslurm.SlurmdbJobRec{}
	jobarray := C.get_all_slurmdb_job()
	c_job := C.job_from_array_by_id(jobarray, C.int(job_id))
	if c_job == nil {
		return slurmJobs
	}
	go_job := Slurmdb_Job_convert_c_to_go(c_job)
	slurmJobs = append(slurmJobs, go_job)
	return slurmJobs
}
